# econ_terms.py
# Created by pasting in the output of a3.get_econ_vocab()
# Mar 2018

"""Defines a list of economic terms scraped from
https://www.economist.com/economics-a-to-z/a
https://www.economist.com/economics-a-to-z/b
...
https://www.economist.com/economics-a-to-z/z"""


ECON_VOCAB = ['absolute advantage', 'adaptive expectations', 'adverse selection', 'advertising', 'agency costs', 'agricultural policy', 'agriculture', 'aid', 'altruism', 'amortisation', 'animal spirits', 'antitrust', 'appreciation', 'arbitrage', 'arbitrage pricing theory', 'asian crisis', 'assets', 'asymmetric information', 'asymmetric shock', 'auctions', 'austrian economics', 'autarky', 'average', 'backwardation', 'balance of payments', 'balanced budget', 'bank', 'bankruptcy', 'barriers to entry (or exit)', 'barter', 'basel 1 and 2', 'basis point', 'bear', 'behavioural economics', 'beta', 'big mac index', 'black economy', 'black-scholes', 'bonds', 'boom and bust', 'bounded rationality', 'brand', 'bretton woods', 'bubble', 'budget', 'bull', 'business confidence', 'business cycle', 'buyer&#039;s market', 'cannibalise', 'capacity', 'capital', 'capital adequacy ratio', 'capital asset pricing model', 'capital controls', 'capital flight', 'capital gains', 'capital intensive', 'capital markets', 'capital structure', 'capitalism', 'capm', 'cartel', 'catch-up effect', 'central bank', 'ceteris paribus', 'charity', 'chicago school', 'classical dichotomy', 'classical economics', 'closed economy', 'coase theorem', 'collateral', 'collusion', 'command economy', 'commoditisation', 'commodity', 'common goods', 'communism', 'comparative advantage', 'competition', 'competitive advantage', 'competitiveness', 'complementary goods', 'compound interest', 'concentration', 'conditionality', 'consumer confidence', 'consumer prices', 'consumer surplus', 'consumption', 'contagion', 'contestable market', 'convergence', 'corruption', 'cost of capital', 'cost-benefit analysis', 'creative destruction', 'credit', 'credit creation', 'credit crunch', 'creditor', 'crony capitalism', 'crowding out', 'currency board', 'currency peg', 'current account', 'de soto', 'hernando', 'deadweight cost/loss', 'debt', 'debt forgiveness', 'debt-equity ratio', 'default', 'deficit', 'deflation', 'demand', 'demand curve', 'demographics', 'deposit insurance', 'depreciation', 'depression', 'deregulation', 'derivatives', 'devaluation', 'developing countries', 'development economics', 'diminishing returns', 'direct taxation', 'discount rate', 'discounted cashflow', 'diseconomies of scale', 'disequilibrium', 'disinflation', 'disintermediation', 'diversification', 'dividend', 'division of labour', 'dollarisation', 'dominant firm', 'dumping', 'ecb', 'econometrics', 'economic and monetary union', 'economic indicator', 'economic man', 'economic rent', 'economic sanctions', 'economics', 'economies of scale', 'effective exchange rate', 'efficiency', 'efficiency wages', 'efficient market hypothesis', 'elasticity', 'emerging markets', 'endogenous', 'engel&#039;s law', 'enron', 'enterprise', 'entrepreneur', 'environmental economics', 'equilibrium', 'equities', 'equity', 'equity risk premium', 'euro', 'euro zone', 'eurodollar', 'european central bank', 'european union', 'evolutionary economics', 'excess returns', 'exchange controls', 'exchange rate', 'exogenous', 'expectations', 'expected returns', 'expenditure tax', 'export credit', 'exports', 'externality', 'factor cost', 'factors of production', 'factory prices', 'fair trade', 'fdi', 'federal reserve system', 'financial centre', 'financial instrument', 'financial intermediary', 'financial markets', 'financial system', 'fine tuning', 'firms', 'first-mover advantage', 'fiscal drag', 'fiscal neutrality', 'fiscal policy', 'fixed costs', 'flotation', 'forecasting', 'foreign direct investment', 'forward contracts', 'free lunch', 'free riding', 'free trade', 'frictional unemployment', 'friedman', 'milton', 'full employment', 'fungible', 'futures', 'g7', 'g8', 'g10', 'g21', 'g22', 'g26', 'game theory', 'gatt', 'gdp', 'gearing', 'general agreement on tariffs and trade', 'general equilibrium', 'generational accounting', 'giffen goods', 'gilts', 'gini coefficient', 'global public goods', 'globalisation', 'gni', 'gnp', 'gold', 'gold standard', 'golden rule', 'government', 'government bonds', 'government debt', 'government expenditure', 'government revenue', 'greenspan', 'alan', 'gresham&#039;s law', 'gross domestic product', 'gross national product', 'growth', 'hard currency', 'hawala', 'hayek', 'friedrich', 'hedge', 'hedge funds', 'herfindahl-hirschman index', 'homo economicus', 'horizontal equity', 'horizontal integration', 'hot money', 'house prices', 'human capital', 'human development index', 'hyper-inflation', 'hypothecation', 'hysteresis', 'ilo', 'imf', 'imperfect competition', 'imports', 'income', 'income effect', 'income tax', 'incumbent advantage', 'index numbers', 'indexation', 'indifference curve', 'indirect taxation', 'inelastic', 'inequality', 'inferior goods', 'inflation', 'inflation target', 'information', 'infrastructure', 'innovation', 'insider trading', 'institutional economics', 'institutional investors', 'insurance', 'intangible assets', 'intellectual capital', 'interest', 'interest rate', 'international aid', 'international labour organisation', 'international monetary fund', 'international trade', 'intervention', 'investment', 'invisible hand', 'invisible trade', 'inward investment', 'j-curve', 'job search', 'joint supply', 'keynes', 'john maynard', 'keynesian', 'kleptocracy', 'kondratieff wave', 'labour', 'labour intensive', 'labour market flexibility', 'labour theory of value', 'laffer curve', 'lagging indicators', 'laissez-faire', 'land', 'land tax', 'law and economics', 'lbo', 'leading indicators', 'lender of last resort', 'leverage', 'leveraged buy-out', 'liberal economics', 'liberalisation', 'libor', 'life', 'life-cycle hypothesis', 'liquidity', 'liquidity preference', 'liquidity trap', 'lock-in', 'long run', 'lump of labour fallacy', 'lump-sum tax', 'luxuries', 'macroeconomic policy', 'macroeconomics', 'manufacturing', 'marginal', 'market capitalisation', 'market failure', 'market forces', 'market power', 'marshall plan', 'marshall', 'alfred', 'marx', 'karl', 'mean', 'mean reversion', 'median', 'medium term', 'menu costs', 'mercantilism', 'mergers and acquisitions', 'microeconomics', 'minimum wage', 'misery index', 'mixed economy', 'mobility', 'mode', 'modelling', 'modern portfolio theory', 'monetarism', 'monetary neutrality', 'monetary policy', 'money', 'money illusion', 'money markets', 'money supply', 'monopolistic competition', 'monopoly', 'monopsony', 'moral hazard', 'most-favoured nation', 'multiplier', 'nafta', 'nairu', 'nash equilibrium', 'nation building', 'national debt', 'national income', 'nationalisation', 'natural monopoly', 'natural rate of unemployment', 'negative income tax', 'neo-classical economics', 'net present value', 'network effect', 'neutrality', 'new economy', 'new growth theory', 'new trade theory', 'ngo', 'nobel prize for economics', 'nominal value', 'non-price competition', 'normal goods', 'normative economics', 'npv', 'null hypothesis', 'oecd', 'offshore', 'okun&#039;s law', 'oligopoly', 'opec', 'open economy', 'open-market operations', 'opportunity cost', 'optimal currency area', 'optimum', 'option', 'output', 'output gap', 'outsourcing', 'outward investment', 'over the counter', 'overheating', 'overshooting', 'pareto efficiency', 'paris club', 'patents', 'path dependence', 'peak pricing', 'percentage point', 'percentile', 'perfect competition', 'permanent income hypothesis', 'phillips curve', 'pigou effect', 'plaza accord', 'population', 'positional goods', 'positive economics', 'poverty', 'poverty trap', 'ppp', 'precautionary motive', 'predatory pricing', 'preference', 'present value', 'price', 'price discrimination', 'price elasticity', 'price mechanism', 'price regulation', 'price/earnings ratio', 'principal-agent theory', 'prisoners&#039; dilemma', 'private equity', 'privatisation', 'probability', 'producer prices', 'producer surplus', 'production function', 'productivity', 'profit', 'profit margin', 'profit maximisation', 'progressive taxation', 'propensity', 'property rights', 'prospect theory', 'protectionism', 'public goods', 'public spending', 'public utility', 'public-private', 'purchasing power parity', 'q theory', 'quantity theory of money', 'quartile', 'queueing', 'quota', 'r squared', 'random walk', 'rate of return', 'rate of return regulation', 'ratings', 'rational expectations', 'rationality', 'rationing', 'real balance effect', 'real exchange rate', 'real interest rate', 'real options theory', 'real terms', 'recession', 'reciprocity', 'redlining', 'reflation', 'regional policy', 'regression analysis', 'regressive tax', 'regulation', 'regulatory arbitrage', 'regulatory capture', 'regulatory failure', 'regulatory risk', 'relative income hypothesis', 'rent', 'rent-seeking', 'replacement cost', 'replacement rate', 'repo', 'required return', 'rescheduling', 'reservation wage', 'reserve currency', 'reserve ratio', 'reserve requirements', 'reserves', 'residual risk', 'restrictive practice', 'returns', 'revealed preference', 'ricardian equivalence', 'ricardo', 'david', 'risk', 'risk averse', 'risk management', 'risk neutral', 'risk premium', 'risk seeking', 'risk-free rate', 'safe harbour', 'satisficing', 'savings', 'say&#039;s law', 'scalability', 'scarcity', 'scenario analysis', 'schumpeter', 'joseph', 'sdr', 'search costs', 'seasonally adjusted', 'second-best theory', 'secondary market', 'securities', 'securitisation', 'seignorage', 'seller&#039;s market', 'seniority', 'sequencing', 'services', 'shadow price', 'shareholder value', 'shares', 'sharpe ratio', 'shock', 'short-termism', 'shorting', 'signalling', 'simple interest', 'smith', 'adam', 'social benefits/costs', 'social capital', 'social market', 'socialism', 'soft currency', 'soft dollars', 'soft loan', 'sovereign risk', 'speculation', 'speculative motive', 'spot price', 'spread', 'stabilisation', 'stability and growth pact', 'stagflation', 'stagnation', 'stakeholders', 'standard deviation', 'standard error', 'statistical significance', 'sterilised intervention', 'sticky prices', 'stochastic process', 'stocks', 'stress-testing', 'structural adjustment', 'structural unemployment', 'subsidy', 'substitute goods', 'substitution effect', 'sunk costs', 'supply', 'supply curve', 'supply-side policies', 'sustainable growth', 'swap', 'systematic risk', 'systemic risk', 'tangible assets', 'tariff', 'tax arbitrage', 'tax avoidance', 'tax base', 'tax burden', 'tax competition', 'tax efficient', 'tax evasion', 'tax haven', 'tax incidence', 'taxation', 'technical progress', 'terms of trade', 'third way', 'tick', 'tiger economies', 'time series', 'time value of money', 'tobin', 'james', 'total return', 'trade', 'trade area', 'trade cycle', 'trade deficit/surplus', 'trade unions', 'trade-weighted exchange rate', 'tragedy of the commons', 'transaction costs', 'transfer pricing', 'transfers', 'transition economies', 'transmission mechanism', 'transparency', 'treasury bills', 'trough', 'trust', 'uncertainty', 'underground economy', 'unemployment', 'unemployment trap', 'unions', 'usury', 'utility', 'value added', 'value at risk', 'variable costs', 'velocity of circulation', 'venture capital', 'vertical equity', 'vertical integration', 'visible trade', 'volatility', 'voluntary unemployment', 'wage drift', 'wages', 'wealth effect', 'wealth tax', 'weightless economy', 'welfare', 'welfare economics', 'welfare to work', 'windfall gains', 'windfall profit', 'winner-takes-all markets', 'withholding tax', 'world bank', 'world trade organisation', 'x-efficiency', 'yield', 'yield curve', 'yield gap', 'zero-sum game']

